# -*- coding: iso-8859-1 -*-
"""
    MoinMoin - IncludeComments Macro

    @copyright: 2013 by Paul Boddie <paul@boddie.org.uk>
    @license: GNU GPL (v2 or later), see COPYING.txt for details.
"""

from MoinMoin.macro import Include
from MoinMoin.wikiutil import escape

Dependencies = ['pages']

# Macro functions.

def execute(macro, text):
    request = macro.request
    fmt = request.formatter
    pagename = request.page.page_name
    _ = request.getText

    included_content = Include.execute(macro, text or "^%s/" % pagename, included_page_css_class="included-comment")

    output = []
    append = output.append

    # Provide a form for adding new comments.

    if request.user.valid and request.user.may.write(pagename):

        d = {
            "show_form"         : escape(_("Add a comment to this page.")),
            "comment_label"     : escape(_("Write a comment in the box.")),
            "comment_default"   : "",
            "submit"            : escape(_("Submit this comment")),
            }

        append("""\
<div id="includecomments-anchor">
<a href="#includecomments-anchor">%(show_form)s</a>
<form action="?action=PostComment" method="post" class="includecomments-form">
<p>%(comment_label)s</p>
<textarea name="comment" cols="60" rows="10">%(comment_default)s</textarea>
<p><input name="submit" type="submit" value="%(submit)s" /></p>
</form>
</div>
""" % d)

    # Add included comments.

    append(included_content)

    return u"".join(output)

# vim: tabstop=4 expandtab shiftwidth=4
